package robo_d;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * Nacitavanie textu a vytvaranie bodov
 * @author kurilluk
 */



public class File {

    public static File outDobry = new File();
    public static File outZly = new File();
    public static File outAdd = new File();
    public static File outVyroba = new File();

    public StringBuilder sb = new StringBuilder();

    public void Read(String path){
        String str;
        try {
            BufferedReader in = new BufferedReader(new FileReader(path));
             while ((str = in.readLine()) != null) {
                sb.append(str).append("\n");
            }
             
            in.close();
            } catch (IOException e) {
            System.out.print(e);
        }
        //return sb;
    }
    public List<Point>ReadText(String path){
        return ReadText(path,false,1,0,0,0);
    }
 /**  Nacitanie suboru do stringu */
    public List<Point> ReadText(String path, boolean reverse, Integer scale,float moveX,float moveY, float moveZ){
         //StringBuilder sb = new StringBuilder(18096);
        ArrayList<Point>pts = new ArrayList<Point>(135000);

         String str;
         String bod[];
         int count;
         //int celok = 0;

        try {
            BufferedReader in = new BufferedReader(new FileReader(path));

            while ((str = in.readLine()) != null) {
                sb.append(str + "\n");
            }
             //Main.Say(".. string divade OK Count " + celok/3);
            in.close();

            // nacitanie celeho suboru a nasledne rozdelenie
            bod = sb.toString().split("\\s+");
            count =  bod.length;
                //overenie spravnosti nacitania bodov
                if(count%3 == 0){
                    Main.Say("position read : OK : points count : " + count/3);
                    float x,y,z;
                    for(int i = 0; i < count /3; i++){
                        x = Float.valueOf(bod[i * 3]).floatValue()+moveX;
                        if(reverse){
                            y = -(Float.valueOf(bod[i * 3+2]).floatValue())+moveY;
                            z = Float.valueOf(bod[i * 3+1]).floatValue()+moveZ;
                        }else{
                            y = Float.valueOf(bod[i * 3+1]).floatValue()+moveY;
                            z = Float.valueOf(bod[i * 3+2]).floatValue()+moveZ;
                        }
                        //Sector.AddPoint(new Point(x*Main.scale,y*Main.scale,z*Main.scale));
                        if(x<15692.2 && x>0 && y<5392.89 && y>0 && z<5592.41 &&z>0){
                        pts.add(new Point(x*scale,y*scale,z*scale));
                        }
                    }
                    Main.Say("DONE : errPoints : " + SectorInfo.ErrPoints);
                    sb.delete(0, sb.length()+1);
                }
                else{
                    Main.Say("ERR: string divade error Count" + count + " modulus " + count%3);
                    //Main.Say(bod[1]);
                }

        } catch (IOException e) {
            System.out.print(e);
        }
         //return sb.toString();
         return pts;
    }

    public void WriteText(String path) {
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter(path));
            out.write(sb.toString());
            sb.delete(0, sb.length()+1);
            out.close();
        } catch (IOException e) {
        }
    }


    public void WriteLine(String str){
        sb.append(str +"\n");

    }

     public void WritePt(String str){
        sb.append("\n"+str +"\n");

    }

    public void WriteVec(String str) {
        sb.append(str + " ; ");

    }

        public void Write(String str) {
        sb.append(str);

    }

    public static void write(){
        outDobry.WriteText(Main.outPut);
        outZly.WriteText(Main.outPut1);
        outAdd.WriteText(Main.outPut2);
    }

    public static void writeVyroba(){
        outVyroba.WriteText(Main.outPut3);
    }

    public static void write(List<Point> pts){
        for(Point pt : pts){
            outDobry.WritePt(pt.toString());
        }
        //System.out.println("File.read : DONE");
        write();
        System.out.println("File.write : DONE");
    }

        public static void write(List<Point> pts,String name){
        outDobry.Write(name);
            for(Point pt : pts){
            outDobry.WritePt(pt.toString());
        }
        //System.out.println("File.read : DONE");
        write();
        System.out.println("File.write : DONE");
    }
    
}//close class
