package robo_d;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author kurilluk
 */
public class Grid1 {
    
    private static float side = (Main.diameter/(float)Math.sqrt(2)); //(x/2^0.5)*2

    public static List<Point> GeneratePoint(XYZ min,XYZ max){

        ArrayList<Point> pts = new ArrayList<Point>();

        for(int z = min.zi; z < max.zi; z += 2){
      //prvy riadok
      for(int x = min.xi; x < max.xi; x += 2){
        for(int y = min.yi; y < max.yi; y += 2){
          pts.add(new Point(x * side, y * side, z * side));
        }
      }
      //druhy riadok
      int z2 = z + 1;
      for(int y = min.yi; y < max.yi; y += 2){
        for(int x = min.xi+1; x < max.xi; x += 2){
          pts.add(new Point (x * side, y * side, z2 * side));
        }
        int y2 = y + 1;
        for(int x = min.xi; x < max.xi; x += 2){
          pts.add(new Point (x * side, y2 * side, z2 * side));
        }
      }
    }
        System.out.println("Grid.GeneratePt : DONE : pts : "+ pts.size());
        return pts;
    }

    public static List<Point> ActivPts(){
        ArrayList<Point> ptsA = new ArrayList<Point>();
        Object[] keys = Sector.GetKeys();
        for(Object key : keys ){
            Point pt = Sector.GetPoint(key);
            //if(pt.activ){
                ptsA.add(pt);
//            }else{
//                Sector.KillPoint(pt);
//            }
        }
        //System.out.println("Grid1.ActivPts : "+ ptsA.size());
        return ptsA;
    }

    public static void PrintActivGrid(){
        //File.write(ActivPts());
    }

}
