package robo_d;

/**
 *
 * @author kurilluk
 */
public class Limit {

    public static XYZ blocksInCut = vypocitajBlokyRezu(Main.limitBlock);

    public static XYZ CutsCount = pocetRezov();

    public static Limit rezy = new Limit();

    private static XYZ vypocitajBlokyRezu(XYZ limit){
        int x,y,z;
        x = (int)(limit.x/Sector.blockSize);
        y = (int)(limit.y/Sector.blockSize);
        z = (int)(limit.z/Sector.blockSize);
        return new XYZ(x,y,z);
    }

    private static XYZ pocetRezov(){
        int x,y,z;
        XYZ max = Sector.getMax();
        XYZ min = Sector.getMin();
        x = (int)((max.xi - min.xi)/blocksInCut.xi)+1;
        y = (int)((max.yi - min.yi)/blocksInCut.yi)+1;
        z = (int)((max.zi - min.zi)/blocksInCut.zi)+1;
        return new XYZ(x,y,z);
    }

//    public static Limit Rezy(){
//        return rezy;
//    }
    
  //============================================================================
            
  public int[] x;
  public int[] y;
  public int[] z;
 
  private Limit(){
      this.x = pole(CutsCount.xi,blocksInCut.xi);
      this.y = pole(CutsCount.yi,blocksInCut.yi);
      this.z = pole(CutsCount.zi,blocksInCut.zi);
  }
  
  private int[] pole(int count,int add){
     int[] pole = new int[count];
      for(int i = 0;i < count; i++){
         pole[i] = add*i;
     }
     return pole;
  }

}
