package robo_d;

import com.sun.j3d.utils.behaviors.vp.OrbitBehavior;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.vecmath.Point3d;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.SimpleUniverse;
//import java.awt.PointerInfo;
import javax.media.j3d.AmbientLight;
import javax.media.j3d.Appearance;
//import javax.media.j3d.ColoringAttributes;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.Material;
import javax.vecmath.Vector3f;

public class View3d extends JApplet {

//    /**Vytvori jedinacika okno pre 3d zobrazenie*/
//    private static JFrame frm = new JFrame("Preview");

//    /** Instancia apletu pre 3d zobraznie*/
//    private static View3d view = new View3d();
//    
    /**Uschovava Geometriu pre zobrazenie*/
    private static BranchGroup bg = createDefaultBG();

    /**Limit alebo pole posobenia zobrazenia*/
    private BoundingSphere bounds =
            new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);

    /**
     * Nahrazuje volání apletu z html stránky vytvořením rámce a přidáním
     * apletu do něj.
     */
    public static void Preview(String name) {
        //fm.removeAll();
        JFrame fm = new JFrame(name);
        JApplet a = new View3d();
        fm.getContentPane().add(a);
        fm.setSize(800, 600);
        //fm.setLocationRelativeTo(null);
        //fm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        fm.setVisible(true);
        a.init();
        a.start();
    }

    /**Zakladne vytvorenie geometrie vesmiru (svetla,..)*/
    private static BranchGroup createDefaultBG() {

        BranchGroup newBG = new BranchGroup();
        AmbientLight al = new AmbientLight();
        al.setInfluencingBounds(new BoundingSphere());
        newBG.addChild(al);

        DirectionalLight dl = new DirectionalLight();
        dl.setInfluencingBounds(new BoundingSphere());
        newBG.addChild(dl);
        return newBG;
    }

    public static void AddPoint(XYZ pt){

            TransformGroup tg = new TransformGroup();
            Transform3D t = new Transform3D();
            Sphere s = new Sphere(Main.diameter/2000, Sphere.GENERATE_NORMALS, createAppearance());
            Vector3f v = new Vector3f(pt.x/1000, pt.y/1000,pt.z/1000);
            t.setTranslation(v);
            tg.setTransform(t);
            tg.addChild(s);
            bg.addChild(tg);

    }

    public static void Reset(){
        bg = createDefaultBG();
    }

    /**Nastavenie zakladneho materialu pre objekt vo vesmire*/
     private static Appearance createAppearance() {
        Appearance a = new Appearance();
        Material m = new Material();
        a.setMaterial(m);
        return a;
    }

    /** Vytvoří instanci apletu, pre ktory vytvori vesmir s bg geometriou*/
    public View3d() {
        Canvas3D c = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        getContentPane().add(c);
        SimpleUniverse u = new SimpleUniverse(c);
        u.getViewingPlatform().setNominalViewingTransform();
        //pohyb pomocou mouseEvent
        OrbitBehavior behavior = new OrbitBehavior();
        behavior.setSchedulingBounds(bounds);
        behavior.setReverseRotate(true);
        u.getViewingPlatform().setViewPlatformBehavior(behavior);
        //pridanie geometrie do vesmiru
        bg.compile();
        u.addBranchGraph(bg);
    }
}

 