package robo_d;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
//import java.util.Random;
/**
 *
 * @author kurilluk
 */
public class Vyrobitelnost {

    public static int minSused = 1;
    public static int maxSuded = 3;

    //doplnenie odmazanie a...
//    public static void Vyroba(List<Point> pt){
//        Vyroba(pt,Sector.blocks,new XYZ(0,0,0));
//    }
    public static Vyroba Vyroba(List<Point> pts,HashMap<Object,Point> map,XYZ index,SubSector sub){

        Vyroba test = new Vyroba(map);

        for(int i = 0; i < pts.size(); i++){
            Point pt = pts.get(i);
            isKoren(pt,sub);
            test.Vyrobitelny(isVyrobitelny(pt,map,index),pt);
        }
        //test.WriteToSector();
        //File.write(Socha.PtSort(map));
        return test; //.ActualPts();
    }

    /**Vypise body do vyroba output.*/
    public static void Vyrobit(SubSector sub) {
        List<Point> pts = sub.GetPts();
        System.out.println("Local point :"+ sub.local.toString());
        System.out.println("Index :"+ sub.index.toString());
        for(int i = 0; i < pts.size();i++){
            pts.get(i).toLocal(sub.local);
        }
        Comparator y = new podlaY();
        Comparator x = new podlaX();
        Collections.sort(pts,x);
        Collections.sort(pts,y);
        Collections.sort(pts);
        for (Point pt : pts) {

            isKoren(pt,sub);
            File.outVyroba.WritePt(pt.printLocal());
            pt.vyrobeny = true;
            if (pt.koren) {
                File.outVyroba.WriteVec("0 : 0 : -1");
            }
            //Susedia okolie = new Susedia();
            Object[] ss = Okolie.SusediaMriezka(pt);
            for (int i = 0; i < 4; i++) {
                Point ptN = Sector.GetPoint(ss[i],sub.GetMap());
                if (ptN != null) {
                    if (ptN.vyrobeny) {
//                        if(pt.Position().z > ptS.Position().z){
//                            if(vektor < 3){ //pre redukciu bodov
                        File.outVyroba.WriteVec(ptN.Position().Subtract(pt.Position()).toString());
//                            vektor ++;
                    }
                }
            }
        }
        File.writeVyroba();
    }


        private static Vyrobitelny isVyrobitelny(Point pt,HashMap<Object,Point> map,XYZ index) {
        if (bodSocha(pt)) {
            return new Vyrobitelny(true);
        }
        Susedia okolie = new Susedia();
        Object[] ss = Okolie.SusediaMriezka(pt);
        for (int i = 0; i < 4; i++) {
            Point ptN = Sector.GetPoint(ss[i],map);
            okolie.Pos(i,(ptN != null));
        }
        if(okolie.count < maxSuded){
            //System.out.println("BODY FALSE");
            return isDoplnitelny(pt,okolie,map,index);
        }else{
            //System.out.println("BODY TRUE");
            return new Vyrobitelny(true);
        }
    }

        private static List<Integer> AnalyzaSpodku(Susedia okolie){
           ArrayList<Integer> addPos = new ArrayList<Integer>();

            for(int i = 0; i < okolie.position.length; i++){
                if(!okolie.position[i]){
                    if(PodkladneBody(okolie, i)){
                        addPos.add(i);
                    }
                }
            }
            return addPos;
        }

        private static boolean PodkladneBody(Susedia okolie, int pozicia){
            int count;
            switch(pozicia){
                case 0:
                    count = okolie.Pod(0)+okolie.Pod(1)+okolie.Pod(2)+okolie.Pod(8);
                    break;

                case 1:
                    count = okolie.Pod(2)+okolie.Pod(3)+okolie.Pod(4)+okolie.Pod(8);
                    break;

                case 2:
                    count = okolie.Pod(4)+okolie.Pod(5)+okolie.Pod(6)+okolie.Pod(8);
                    break;

                case 3:
                    count = okolie.Pod(6)+okolie.Pod(7)+okolie.Pod(0)+okolie.Pod(8);
                    break;

                default:
                    count = 0;
                    System.out.println("PodkladyBody out of count");
            }
            if(count>0){return true;}
            return false;
        }

        private static Point DoplnitBod(Point pt, Integer smer,HashMap<Object,Point> map){
            Point ptN = AddPoint(pt,smer);
            //System.out.println("Pridavam bod : "+ ptN.toString());
            File.outAdd.WritePt(ptN.toString());
            Sector.AddPoint(ptN,map);
            return ptN;
        }

    private static List<Pozicia> Efektivita(Point pt,List<Integer> addPos) {
        List<Pozicia> poz = new ArrayList<Pozicia>();
        for (int p : addPos) {
            int count = 0;
            Point ptN = AddPoint(pt,p);
            Object[] ss = Okolie.SusediaMriezka(ptN);
            for (int i = 4; i < 8; i++) {
                Point ptU = Sector.GetPoint(ss[i]);
                count += (ptU != null)? 1 : 0;
            }
            poz.add(new Pozicia(p, count));
        }
        Collections.sort(poz);
        Collections.reverse(poz);
        return poz;
    }

        /**Kontroluje doplnitelnost a snazi sa bod doplnit, ak sa mu to nepodari false*/
        private static Vyrobitelny isDoplnitelny(Point pt, Susedia okolie,HashMap<Object,Point> map,XYZ index){
            ArrayList<Point> doplnene = new ArrayList<Point>();
            podSusedia(pt, okolie,map);
            //TODO minSused zmenit na podsused alebo lepsie doplnit podsusedov v predoslej metode
            //if(okolie.podSusediaCount < 2){return new Vyrobitelny(false);}//vymaze bod
            List<Integer> addPos = AnalyzaSpodku(okolie);
            List<Pozicia> addPoz = Efektivita(pt, addPos);
//            Random rnd = new Random();
            for(int i = 0;i < addPoz.size(); i++){
//            while (addPos.size() > 0) {
//                int i = (int) (addPos.size() * rnd.nextDouble());
                //TODO OVERENIE CI BOD NIE JE MIMO LIMIT
                Point ptD = AddPoint(pt, addPoz.get(i).pozicia);
                if(nieJeMimoLimit(pt,ptD,index)){
                doplnene.add(ptD);
                okolie.Pos(addPoz.get(i).pozicia, true);
//                addPos.remove(i);
                }
                if (okolie.count == maxSuded) {
                    return new Vyrobitelny(true, doplnene);
                }
            }
            if (okolie.count >= minSused) {
                return new Vyrobitelny(true, doplnene);
            }
            return new Vyrobitelny(false);
        }

        private static boolean  nieJeMimoLimit(Point pt, Point ptD,XYZ index){
            //System.out.println("PT A : "+pt.toSubSector().toKey()+"  PT B :"+ptD.toSubSector().toKey());
            XYZ sub = ptD.Position().DivideUni(Sector.blockSize);
            XYZ pos = index.Multy(SubSector.subCount);
            //System.out.println("mimoLimit Mensie :"+sub.toString()+" index "+pos.toString());
            if(sub.isSmaller(pos)){return false;}
            pos = pos.Add(SubSector.subCount.SubtractUni(1));
            //System.out.println("mimoLimit Vacsie :"+sub.toString()+" index "+pos.toString());
            if(pos.isSmaller(sub)){return false;}
            return true;
           //return (pt.toSubSector().toKey().equals(ptD.toSubSector().toKey()));
        }


    private static Point AddPoint(Point pt, int index) {
        float x, y, z;
        switch (index) {
            case 0:
                //System.out.println("vyberam a doplnam");
                x = pt.Position().x + Sector.blockSize;
                y = pt.Position().y + Sector.blockSize;
                z = pt.Position().z - Sector.blockSize;
                break;

                case 1:
                //System.out.println("vyberam a doplnam");
                x = pt.Position().x + Sector.blockSize;
                y = pt.Position().y - Sector.blockSize;
                z = pt.Position().z - Sector.blockSize;
                break;

                case 2:
                //System.out.println("vyberam a doplnam");
                x = pt.Position().x - Sector.blockSize;
                y = pt.Position().y - Sector.blockSize;
                z = pt.Position().z - Sector.blockSize;
                break;

                case 3:
                //System.out.println("vyberam a doplnam");
                x = pt.Position().x - Sector.blockSize;
                y = pt.Position().y + Sector.blockSize;
                z = pt.Position().z - Sector.blockSize;
                break;
            default:
                //TODO new try error out of range
                System.out.println("Chyba vyber swith default");
                x = 0;
                y = 0;
                z = 0;
                break;

        }
        return new Point(x, y, z);
    }

    private static void podSusedia(Point pt, Susedia okolie,HashMap<Object,Point> map) {
        //if is koren
        if ((pt.Position().z - Sector.blockSize)< 0.2f) {
            for (int i = 0; i < 9; i++) {
                okolie.Pod(i,true);
            }
        } else {
            Object[] ss = Okolie.PodSusedia(pt);
            for (int i = 0; i < 9; i++) {
                Point ptN = Sector.GetPoint(ss[i],map);
                okolie.Pod(i, (ptN != null));
            }
        }
    }

    private static boolean bodSocha(Point pt){
        if(pt.koren || pt.kmen){
            return true;
        }
        return false;
    }

    private static void isKoren(Point pt, SubSector sub) {
        pt.toLocal(sub.local);
        if(pt.PositionL().z < 10){
            pt.koren = true;
        }
//        int vyskaRezu = 366;
//        int vrstvyRezu = (int) (vyskaRezu / Sector.blockSize);
//        float suradnica = vrstvyRezu * Sector.blockSize;
//        for (int i = 0; i < 10; i++) {
//            if (pt.Position().z == suradnica * i) {
//                pt.koren = true;
//                return;
//            }
//        }
        //TODO if local z = 0 then koren if null global..?
}

} //close class

