package robo_d;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author kurilluk
 */
public class Active {

    private static HashMap<Object, Point> map = new HashMap<Object, Point>(125000);

    //private static List<Point> pts;
    public static void LoadSec(int start, int stop) {
        reset();
        File reader = new File();

        //klenba zatial final 00KP4B1D 6470kB
        //okolie doplnene klenby final Z3K (s je statika)
        //posledne pre citatelnost klenbaZahustena (zaloha v ZAL)
        Load(reader.ReadText(Main.path + "okno" + "_F.txt"));
       if (stop < 0) {
            for (int i = start; i <= stop; i = i + 1) {
                String cesta = Main.path + ((i < 10) ? "000" : (i < 100) ? "00" : "0") + i;
                Load(reader.ReadText(cesta + "_F.txt"));
            }
       } //end if stop
    }

    public static void Load(List<Point> ptsN) {
        //reset();
        for (int i = 0; i < ptsN.size(); i++) {
            Point pt = ptsN.get(i);
            map.put(Sector.PointBlock(pt.Position()).toKey(), pt);
        }
    }

    public static Collection<Point> MapPoints() {
        return map.values();
    }

    public static Point GetPoint(Object key) {
        if (map.containsKey(key)) {
            return (Point) map.get(key);
        } else {
            return null;
        }

    }

    public static void SetMap(HashMap<Object,Point> mapa){
        map = mapa;
    }

    private static void reset() {
        map.clear();
    }
} //close class

