package robo_d;

import java.util.List;
import java.util.ArrayList;

/**
 *
 * @author kurilluk
 */
public class Grid2 {

    /**Parameter hustoty - do akej vzdialenosti vidi aktivacny bod.
     * Ak bod vidi aktivuje sa a vytvori*/
    public static final float viewDistance = 28.0f;

    /**Strana zakladneho bloku, totozna s hranou bloku sektoru */
    private static float side = Sector.blockSize;
            //(Main.diameter/(float)Math.sqrt(3));

    /**Generator vytvorenia mriezky s aktivovanim (ulozenim aktivnych) bodov*/
    public static List<Point> GeneratePoint(XYZ min, XYZ max) {

        ArrayList<Point> pts = new ArrayList<Point>(200000);
        Point pt = new Point();
        int x1,y1;
        //x = min.xi;
        //y = min.yi;
        //int z = min.zi;

        for (int z = min.zi; z < max.zi; z++) {
            if (z % 2 > 0) {
                //druhy riadok
                for (int y = min.yi; y < max.yi; y ++) {
                    if(y % 2 == 0){continue;}else{y1= y;}
                    for (int x = min.xi; x < max.xi; x ++) {
                        if(x % 2 == 0){continue;}else{x1 =x;}
                        pt.Set(x1 * side, y1 * side, z * side);
                        //pt = new Point(x * side, y * side, z2 * side);
                        if (Aktivuj(pt)) {
                            pts.add(new Point(pt.Position()));
                        }
                    }
                }
            } else {
                //prvy riadok
                for (int x = min.xi; x < max.xi; x ++) {
                    if(x % 2 > 0){continue;}else{x1 =x;}
                    for (int y = min.yi; y < max.yi; y ++) {
                        if(y % 2 > 0){continue;}else{y1= y;}
                        pt.Set(x1 * side, y1 * side, z * side);
                        //pt = new Point(x * side, y * side, z * side);
                        if (Aktivuj(pt)) {
                            pts.add(new Point(pt.Position()));
                        }
                    }
                }
            }
        }
       System.out.println("Grid.GeneratePts : " + pts.size());
        return pts;
    }

    /**Otestuje ci sa v sektore nachazda aktivacny bod pre bod mriezky*/
     private static boolean Aktivuj(Point pt) {

        Object[] keys = Okolie.Bliske(pt);

        for (Object key : keys) {
            Point ptN = Active.GetPoint(key);
            if (ptN != null) {
                float dist = (float) (Calc.Distance(pt.Position(), ptN.Position()));
                //System.out.println("Active.OkolieBodu dist : " + dist);
                if (dist < Main.Hustota()) {
                return true;
                }
            }
        }
        return false;
    }

//    /**Bliske okolie bodu, vrati zoznam KEY pre sector (HashMap).*/
//    private static List<Object> BlizkeOkolieBodu(Point pt) {
//        XYZ i = Sector.PointBlock(pt.Position());
//        int plus = 1;
//        int zLim = i.zi + plus;
//        ArrayList<Object> keys = new ArrayList<Object>();
//
//        //okolie bodu
//        for (int x = i.xi - plus; x <= i.xi + plus; x++) {
//            for (int y = i.yi - plus; y <= i.yi + plus; y++) {
//                for (int z = i.zi - plus; z <= zLim; z++) {
//                    keys.add(new XYZ(x, y, z).toKey());
//                }
//            }
//        }
//        return keys;
//    }

}//close class
