package robo_d;

import java.util.List;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

/**
 *
 * @author kurilluk
 */
public class Socha {

        public static List<Point> PtSort(){
            return PtSort(Sector.blocks);
        }

        public static List<Point> PtSort(HashMap<Object,Point> map){
       //Point[] SortPts = (Point[])Sector.map.values().toArray();
        Object[] key = Sector.GetKeys(map);
        //Object[] key1 = map.keySet().toArray();
        ArrayList<Point>Pts = new ArrayList<Point>(key.length);
         for(int i = 0; i < key.length; i++){
                 Pts.add(Sector.GetPoint(key[i], map));
                 //Pts.add(Sector.GetPoint(key1[i], map));

         }
        Collections.sort(Pts);
        return Pts;
    }


    public static void Test(List<Point> pts) {
        
        for(int i = 0; i < pts.size(); i++){
            Point pt = pts.get(i);
            isKoren(pt);
            isSocha(pt);
        }
        //spiatocka - overenie iba sochy nie vyrobitelnosti
        for(int i = pts.size()-1; i >= 0; i--){
            Point pt = pts.get(i);
            if(isSocha(pt)){
                File.outDobry.WritePt(pt.toString());
            }else{
                File.outZly.WritePt(pt.toString());
            }
        }
        File.write();
    }

    private static boolean isSocha(Point pt) {
        if (bodSocha(pt)) {
            return true;
        }

        Object[] ss = Okolie.Bliske(pt);
        for (Object s : ss) {
            Point ptN = Sector.GetPoint(s);
            if (ptN != null) {
                if (bodSocha(ptN)) {
                    pt.kmen = true;
                    return true;

                }
            }

        }
        return false;
    }

    private static boolean bodSocha(Point pt){
        if(pt.koren || pt.kmen){
            return true;
        }
        return false;
    }

    private static void isKoren(Point pt) {
        int vyskaRezu = 365;
        int vrstvyRezu = (int) (vyskaRezu / Sector.blockSize);
        float suradnica = vrstvyRezu * Sector.blockSize;
        for (int i = 0; i < 10; i++) {
            if (pt.Position().z == suradnica * i) {
                pt.koren = true;
                return;
            }
        }
    }



}//close class
