package robo_d;

//import java.util.Vector;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;

//import java.awt.Color;
//import java.awt.event.MouseEvent;
/**
 * Okno JFrame
 * @author kurilluk
 */
public class Window extends javax.swing.JFrame {

    /** Deklarovanie jedinacka window */
    static private Window window = new Window();
    private String mso = "";
    public static Object key;

    /** Creates new form window */
    private Window() {
        initComponents();
    }

    /** Zobrazenie a predanie jedinacka window */
    static public Window GetIt() {
        window.setVisible(true);
        window.setLocationRelativeTo(null);
        return window;
    }

    /** Zadanie cesty s suboru */
    public void SetPath(String text) {
        readPath.setText(text);
    }

    public void Say(String ms) {
        String text;
        text = "<|| " + mso + " \n||| \n||> " + ms;
        console.setText(text);
        mso = ms;
    }

    public void ReadIt() {
        File inPut = new File();
        Buttons(false);
        //Reset all created thinks (inplement in create method)
        //if(!Sector.Reset()) Main.Say("ERR: no clear sectors");
        //subSectors.removeAll();
        //Main.Say( "Reading : " + readPath.getText());
        //Active.Load(inPut.ReadText(readPath.getText()));
        Active.LoadSec(new Integer(startFrame.getText()), new Integer(endFrame.getText()));
        SubSector.CreateSubSectors(Active.MapPoints());
        List();

        Buttons(true);
        //vymaze subory..
        //File.write();
        //TODO info o subSektore by som dal az na dalsie tlacitko
        //Info("SubSector size : " + SubSector.subSectorSize.toString() + " mm");


    }

    public void Buttons(boolean b) {
        readFile.setEnabled(b);
        find.setEnabled(b);
    }

    /** Nacitanie subSektorov do jListu v okne */
    public void List() {
        subSectors.setListData(SubSector.ListSubSectors());
    }

    public int GetSliderNumber() {
        return slider.getValue();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        readPath = new javax.swing.JTextField();
        readFile = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        subSectors = new javax.swing.JList();
        find = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        console = new javax.swing.JTextPane();
        testSub = new javax.swing.JButton();
        vyroba = new javax.swing.JButton();
        slider = new javax.swing.JSlider();
        info1 = new javax.swing.JLabel();
        subFinder = new javax.swing.JTextField();
        info2 = new javax.swing.JLabel();
        NoHustota = new javax.swing.JTextField();
        infoHustota = new javax.swing.JLabel();
        minSusedBox = new javax.swing.JTextField();
        info3 = new javax.swing.JLabel();
        info4 = new javax.swing.JLabel();
        maxSudedBox = new javax.swing.JTextField();
        bloky = new javax.swing.JButton();
        rib = new javax.swing.JButton();
        frame = new javax.swing.JTextField();
        statika = new javax.swing.JButton();
        endFrame = new javax.swing.JTextField();
        startFrame = new javax.swing.JTextField();
        info5 = new javax.swing.JLabel();
        info6 = new javax.swing.JLabel();
        info7 = new javax.swing.JLabel();
        reverse = new javax.swing.JCheckBox();
        info8 = new javax.swing.JLabel();
        celok = new javax.swing.JButton();
        entita = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("robo_d");
        setAlwaysOnTop(true);
        setBackground(new java.awt.Color(0, 0, 0));
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("robo_d"); // NOI18N

        readPath.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        readPath.setText("path");
        readPath.setPreferredSize(new java.awt.Dimension(32, 25));

        readFile.setBackground(new java.awt.Color(255, 255, 255));
        readFile.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        readFile.setText("Read It");
        readFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                readFileActionPerformed(evt);
            }
        });

        subSectors.setBackground(new java.awt.Color(0, 0, 0));
        subSectors.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 5, true));
        subSectors.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        subSectors.setForeground(new java.awt.Color(255, 255, 255));
        subSectors.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        subSectors.setToolTipText("");
        subSectors.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        subSectors.setLayoutOrientation(javax.swing.JList.HORIZONTAL_WRAP);
        subSectors.setVisibleRowCount(20);
        subSectors.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                subSectorsMouseReleased(evt);
            }
        });
        jScrollPane1.setViewportView(subSectors);

        find.setBackground(new java.awt.Color(255, 255, 255));
        find.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        find.setText("Find_view");
        find.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findActionPerformed(evt);
            }
        });

        console.setBackground(new java.awt.Color(0, 0, 0));
        console.setBorder(javax.swing.BorderFactory.createEmptyBorder(5, 5, 5, 5));
        console.setFont(new java.awt.Font("Lucida Console", 0, 10));
        console.setForeground(new java.awt.Color(204, 204, 255));
        jScrollPane2.setViewportView(console);

        testSub.setBackground(new java.awt.Color(255, 255, 255));
        testSub.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        testSub.setText("test");
        testSub.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                testSubMousePressed(evt);
            }
        });

        vyroba.setBackground(new java.awt.Color(255, 255, 255));
        vyroba.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        vyroba.setText("VYROBA");
        vyroba.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                vyrobaMousePressed(evt);
            }
        });

        slider.setMaximum(60);
        slider.setMinimum(20);
        slider.setValue(30);
        slider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderStateChanged(evt);
            }
        });

        info1.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info1.setText("hustota gridu :");

        subFinder.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        subFinder.setText("0 : 0 : 0");
        subFinder.setPreferredSize(new java.awt.Dimension(32, 25));

        info2.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info2.setText("subSector :");

        NoHustota.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        NoHustota.setText("30");
        NoHustota.setPreferredSize(new java.awt.Dimension(32, 25));
        NoHustota.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                NoHustotaCaretUpdate(evt);
            }
        });

        infoHustota.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        infoHustota.setText("30");

        minSusedBox.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        minSusedBox.setText("1");
        minSusedBox.setPreferredSize(new java.awt.Dimension(32, 25));
        minSusedBox.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                minSusedBoxCaretUpdate(evt);
            }
        });

        info3.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info3.setText("sused :");

        info4.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info4.setText("max");

        maxSudedBox.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        maxSudedBox.setText("3");
        maxSudedBox.setPreferredSize(new java.awt.Dimension(32, 25));
        maxSudedBox.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                maxSudedBoxCaretUpdate(evt);
            }
        });

        bloky.setBackground(new java.awt.Color(255, 255, 255));
        bloky.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        bloky.setText("bloky");
        bloky.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                blokyMousePressed(evt);
            }
        });

        rib.setBackground(new java.awt.Color(255, 255, 255));
        rib.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        rib.setText("RIB");
        rib.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                ribMousePressed(evt);
            }
        });

        frame.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        frame.setPreferredSize(new java.awt.Dimension(32, 25));
        frame.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                frameCaretUpdate(evt);
            }
        });

        statika.setBackground(new java.awt.Color(255, 255, 255));
        statika.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        statika.setText("statika");
        statika.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                statikaMousePressed(evt);
            }
        });

        endFrame.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        endFrame.setText("173");
        endFrame.setPreferredSize(new java.awt.Dimension(32, 25));
        endFrame.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                endFrameCaretUpdate(evt);
            }
        });
        endFrame.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                endFrameActionPerformed(evt);
            }
        });

        startFrame.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 12));
        startFrame.setText("171");
        startFrame.setPreferredSize(new java.awt.Dimension(32, 25));
        startFrame.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                startFrameCaretUpdate(evt);
            }
        });

        info5.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info5.setText("load frames :");

        info6.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info6.setText("end");

        info7.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info7.setText("start");

        reverse.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        reverse.setText("R");
        reverse.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);

        info8.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        info8.setText("min");

        celok.setBackground(new java.awt.Color(255, 255, 255));
        celok.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        celok.setText("celok");
        celok.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                celokMousePressed(evt);
            }
        });

        entita.setBackground(new java.awt.Color(255, 255, 255));
        entita.setFont(new java.awt.Font("Lucida Sans Unicode", 0, 10));
        entita.setText("entita");
        entita.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                entitaMousePressed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 359, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 359, Short.MAX_VALUE)
                    .addComponent(readPath, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 359, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(info2)
                                    .addComponent(info3)
                                    .addComponent(info1))
                                .addGap(13, 13, 13)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(infoHustota)
                                    .addComponent(info8)))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(info5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(info7)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(NoHustota, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(subFinder, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                    .addComponent(startFrame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGap(18, 18, 18)
                                    .addComponent(info6)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(endFrame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(slider, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                            .addComponent(minSusedBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addGap(18, 18, 18)
                                            .addComponent(info4)))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(maxSudedBox, 0, 0, Short.MAX_VALUE))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 66, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(find)
                            .addComponent(vyroba)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(reverse)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(testSub))
                            .addComponent(readFile)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(entita)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(celok)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bloky)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(statika)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(frame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(rib)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 359, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(readPath, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(readFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(info2)
                            .addComponent(find))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(info3, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(testSub)
                            .addComponent(reverse))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(vyroba)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(rib)
                            .addComponent(frame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(statika, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(bloky)
                            .addComponent(celok)
                            .addComponent(entita, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(5, 5, 5))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(startFrame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(info7)
                            .addComponent(info5)
                            .addComponent(info6)
                            .addComponent(endFrame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(9, 9, 9)
                        .addComponent(subFinder, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(minSusedBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(info4)
                            .addComponent(maxSudedBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(info8))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(NoHustota, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(slider, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(infoHustota, javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(info1)))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /** Nacitanie bodov z adresy suboru a vytvorenie subSektorov */
    private void readFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readFileActionPerformed
        ReadIt();
    }//GEN-LAST:event_readFileActionPerformed

    /** vypocitanie susedov bodov subSektoru */
    private void findActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findActionPerformed

        //Object o = subSectors.getModel().getElementAt(index);
        Object o = subFinder.getText();
        key = o;

        subSectors.setSelectedValue(o, true);
        SubSector ss = SubSector.subSectors.get(o);
        int index = subSectors.getAnchorSelectionIndex();
        //ss.Pts = null;
        //if(ss.Pts == null){
        //generate grid for subsector
        XYZ base = ss.index.MultyInt(SubSector.subCount);
        ss.SetPts(Grid2.GeneratePoint(base, base.Add(SubSector.subCount)));
        System.out.println("Window.find : base " + base);
        //}
        SectorInfo.subSector(o, index);
        File.write(ss.GetPts(), ss.toFile());

        //ss.Pts = null;
        //View3d.Reset();
        //Sector.NeighbourhoodForPoints(o);
        // View3d.AddPoint(new XYZ(0.0f,0.0f,0.0f));
        //View3d.Preview(o.toString());
    }//GEN-LAST:event_findActionPerformed

    private void subSectorsMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_subSectorsMouseReleased
        int index = subSectors.locationToIndex(evt.getPoint());
        if (index >= 0) {
            Object o = subSectors.getModel().getElementAt(index);
            //jList1.getComponentAt(evt.getPoint()).setForeground(Color.red);
            key = o;
            subFinder.setText((String) o);
            //SectorInfo.subSector(o,index);
            //Main.Say("Double-clicked on: " + o.toString());
        }
    }//GEN-LAST:event_subSectorsMouseReleased

    private void testSubMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_testSubMousePressed
//.Test(SubSector.subSectors.get(Window.key).Pts);
        SubSector subS = SubSector.subSectors.get(Window.key);
        if (subS.GetPts() != null) {
            //TODO prekovat! na nacitanie sub a vytvorenie mapy
            //subS.SetPts(
            if (reverse.isSelected()) {
                //                HashMap<Object,Point> mapa = subS.VytvorMapu(true);
                //                Object[] keys = mapa.keySet().toArray();
                //                List<Point> points = new ArrayList<Point>(keys.length+1);
                //                for(Object keyP : keys){
                //                    points.add(mapa.get(keyP));
                //                }
                //                points = SubSector.SortPts(points);
                //                subS.SetPts(Vyrobitelnost.Vyroba(points,subS.GetMap(),subS.index).ActualPts());
                Vyroba test = Overovanie.OtestujReverse(subS);
                subS.SetPts(test.ActualPts());
                test.WriteToSector(); //TODO need to by reversed;
                File.write(Socha.PtSort(subS.VytvorMapu(false)),subS.toFile());
                //File.write(test.ActualPts());
                
            } else {
                Vyroba test = Overovanie.OtestujNormal(subS);
                subS.SetPts(test.ActualPts());
                test.WriteToSector();
                File.write(test.ActualPts(),subS.toFile());
                
            }
        } else {
            System.out.println("SECTOR JE NULL");
        }
    }//GEN-LAST:event_testSubMousePressed

    private void vyrobaMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_vyrobaMousePressed
        Vyrobitelnost.Vyrobit(SubSector.subSectors.get(Window.key));
    }//GEN-LAST:event_vyrobaMousePressed

    private void NoHustotaCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_NoHustotaCaretUpdate
        if (NoHustota.getText() == null ? "" != null : !NoHustota.getText().equals("")) {
            int hustota = new Integer(NoHustota.getText());

            if (hustota < slider.getMinimum()) {
                hustota = slider.getMinimum();
            }
            if (hustota > slider.getMaximum()) {
                hustota = slider.getMaximum();
            }

            slider.setValue(hustota);
        }

    }//GEN-LAST:event_NoHustotaCaretUpdate

    private void sliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sliderStateChanged
        infoHustota.setText("" + slider.getValue());
    }//GEN-LAST:event_sliderStateChanged

    private void minSusedBoxCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_minSusedBoxCaretUpdate
        if (minSusedBox.getText() == null ? "" != null : !minSusedBox.getText().equals("")) {
            Vyrobitelnost.minSused = new Integer(minSusedBox.getText());
            System.out.println("Set minSused to :" + Vyrobitelnost.minSused);
        }
    }//GEN-LAST:event_minSusedBoxCaretUpdate

    private void maxSudedBoxCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_maxSudedBoxCaretUpdate
        if (maxSudedBox.getText() == null ? "" != null : !maxSudedBox.getText().equals("")) {
            Vyrobitelnost.maxSuded = new Integer(maxSudedBox.getText());
            System.out.println("Set maxSused to :" + Vyrobitelnost.maxSuded);
        }
    }//GEN-LAST:event_maxSudedBoxCaretUpdate

    private void blokyMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_blokyMousePressed
        // TODO add your handling code here:
        int count = 0;
        for (Object k : SubSector.subSectors.keySet().toArray()) {
            SubSector ss = SubSector.subSectors.get(k);
            XYZ base = ss.index.MultyInt(SubSector.subCount);
            ss.SetPts(Grid2.GeneratePoint(base, base.Add(SubSector.subCount)));
            if (ss.PtsSize() > 0) {
                File.write(ss.GetPts(), ss.toFile());
                count++;
                System.out.println("Blok cislo " + count);
                try {
                    Thread.sleep(500);
                } catch (Exception e) {
// e.printStackTrace();
                }
            }

        }
    }//GEN-LAST:event_blokyMousePressed

    private void ribMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ribMousePressed
//      Rib.RibCut();
        Rib.RibLoad(new Integer(frame.getText()));
    }//GEN-LAST:event_ribMousePressed

    private void frameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_frameCaretUpdate
        // TODO add your handling code here:
//       Integer f = new Integer(frame.getText());
//        Rib.RibLoad(f);
    }//GEN-LAST:event_frameCaretUpdate

    private void statikaMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_statikaMousePressed
        // TODO add your handling code here:
        Statika celok = new Statika();

        for (Object k : SubSector.subSectors.keySet().toArray()) {
            SubSector ss = SubSector.subSectors.get(k);
            XYZ base = ss.index.MultyInt(SubSector.subCount);
            celok.SetPts(Grid2.GeneratePoint(base, base.Add(SubSector.subCount)));
        }

        //Entita.AnalyzeMap(celok.mapa);
        celok.WriteStatika();

    }//GEN-LAST:event_statikaMousePressed

    private void endFrameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_endFrameCaretUpdate
        // TODO add your handling code here:
    }//GEN-LAST:event_endFrameCaretUpdate

    private void startFrameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_startFrameCaretUpdate
        // TODO add your handling code here:
    }//GEN-LAST:event_startFrameCaretUpdate

    private void endFrameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_endFrameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_endFrameActionPerformed

    private void celokMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_celokMousePressed
        // TODO add your handling code here:
        int count = 0;
        for (Object k : SubSector.subSectors.keySet().toArray()) {
            SubSector ss = SubSector.subSectors.get(k);
            XYZ base = ss.index.MultyInt(SubSector.subCount);
            ss.SetPts(Grid2.GeneratePoint(base, base.Add(SubSector.subCount)));
            //obmedzenie min poctu bodov v bloku
            if (ss.PtsSize() > 0) {

//                Vyroba test = Overovanie.OtestujNormal(ss);
//                //ss.SetPts(test.ActualPts());
//                //test.WriteToSector();
//                File.write(test.ActualPts(),ss.toFile());
                
                //File.write(ss.GetPts(),ss.toFile());

                File.write(Overovanie.Doplnovanie(ss),ss.toFile());
                count++;
                System.out.println("Blok cislo " + count);
                try {
                    Thread.sleep(500);
                } catch (Exception e) {
// e.printStackTrace();
                }
            }

        }
    }//GEN-LAST:event_celokMousePressed

    private void entitaMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_entitaMousePressed
        // TODO add your handling code here:
        Statika celokA = new Statika();

        for (Object k : SubSector.subSectors.keySet().toArray()) {
            SubSector ss = SubSector.subSectors.get(k);
            XYZ base = ss.index.MultyInt(SubSector.subCount);
            celokA.SetPts(Grid2.GeneratePoint(base, base.Add(SubSector.subCount)));
        }

        System.out.println("MAPA READY, ANALYZE MAP ENTITY");


        Entita.AnalyzeMap(celokA.mapa);

    }//GEN-LAST:event_entitaMousePressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField NoHustota;
    private javax.swing.JButton bloky;
    private javax.swing.JButton celok;
    private javax.swing.JTextPane console;
    private javax.swing.JTextField endFrame;
    private javax.swing.JButton entita;
    private javax.swing.JButton find;
    private javax.swing.JTextField frame;
    private javax.swing.JLabel info1;
    private javax.swing.JLabel info2;
    private javax.swing.JLabel info3;
    private javax.swing.JLabel info4;
    private javax.swing.JLabel info5;
    private javax.swing.JLabel info6;
    private javax.swing.JLabel info7;
    private javax.swing.JLabel info8;
    private javax.swing.JLabel infoHustota;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField maxSudedBox;
    private javax.swing.JTextField minSusedBox;
    private javax.swing.JButton readFile;
    private javax.swing.JTextField readPath;
    private javax.swing.JCheckBox reverse;
    private javax.swing.JButton rib;
    private javax.swing.JSlider slider;
    private javax.swing.JTextField startFrame;
    private javax.swing.JButton statika;
    private javax.swing.JTextField subFinder;
    private javax.swing.JList subSectors;
    private javax.swing.JButton testSub;
    private javax.swing.JButton vyroba;
    // End of variables declaration//GEN-END:variables
}
